/***************************************************************************
 *   Copyright (C) 2007 by Julien Keller   *
 *   j.keller@imperial.ac.uk   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include <complex>
#include "MMatrix.h"  //Contains library to handle quickly matrices in memory
#define Complex  std::complex<double>

/* See m_matrix.cpp file for details on procedures */

void show(MMatrix<double>);
void show(MMatrix<int>);
void show(MMatrix<Complex>);
void show(MMatrix<double>,char*);

MMatrix<double>& invertNonZeroElements(MMatrix<double>& M); //inverts each non-zero element of M and replaces it in M. Zero elements are left 0. Another reference to M is returned for convenience.
MMatrix<double> inverse_elements(MMatrix<double>);
MMatrix<double> transpose(MMatrix<double>);
MMatrix<double> transpose2(MMatrix<double>);	
double  scalar_product(MMatrix<double>,MMatrix<double>);


/* These procedures can always be improved */
MMatrix<double> multiply(MMatrix<double>,MMatrix<double>);
void mult(MMatrix<double>&,MMatrix<double>);
Complex determinant3x3(MMatrix<Complex>);
double determinant3x3(MMatrix<double> M);
double spectral_radius(MMatrix<double>);




